[TITLE]
27C256(12.5V)

[AUTORUN]
setup

[MENU]
erace,0,,mF
main,1,r,݁{xt@C
read,0,w,ǂݏo
verify,0,r,xt@C

[MESSAGE]

[COMPILE]
on

[CODE]
// 2000/05/22 Q͖͂Aُ펞̔ѐ惉xԈႢC
// 2000/08/27 foCXɐMLOWxɂȂ悤ɏC
//           A0                                A14
#port	A	"10,9,8,7,6,5,4,3,37,36,33,35,2,38,39"
//           D0                   D7
#port	D	"11,12,13,27,28,29,30,31"
#define	VPP		#VPP1
#define	VPP.dir	#VPP1.dir
#define	VCC		#VCC40
#define	VCC.dir	#VCC40.dir
#define	GND		#GND14
#define	GND.dir	#GND14.dir
#define	#CE		#32
#define	#CE.dir	#32.dir
#define	#OE		#34
#define	#OE.dir	#34.dir

#define	HIGH	1
#define	LOW		0
#define	MEM_SIZE	0x8000
#define	BUFF_SIZE	1024

WORD	AD, AH, AL, Len;
BYTE	Retry;
BYTE	Data;
BYTE	Status;
BYTE	Flg;
BYTE	Buff[BUFF_SIZE];

setup()
{
	InitIo();
	InitVolt();
	VppVolt( 0 );	VccVolt( 0 );
	GND.dir = 1;	GND = ON;
	VCC.dir = 1;	VCC = LOW;
	VPP.dir = 1;	VPP = LOW;
	#CE.dir = HIGH;	#CE = HIGH;
	#OE.dir = HIGH;	#OE = HIGH;
	A.dir = 0xffff;	A = 0;
	D.dir = 0xff;	D = 0;
	Message( "Pԃsɍ킹ăfoCXZbgĉ" );
}

PowerOn_5V()
{
	A = 0;
	D = 0;
	VccVolt( 5.0 );
	VCC = HIGH;
	#OE = HIGH;
	#CE = HIGH;
}

PowerOn_6V()
{
	A = 0;
	D = 0;
	VccVolt( 6.0 );
	VCC = HIGH;
	#OE = HIGH;
	#CE = HIGH;
	VppVolt( 12.5 );
	VPP = HIGH;
}

PowerOff()
{
	VPP = LOW;
	VCC = LOW;
	D.dir = 0xff;
	#OE = LOW;
	#CE = LOW;
}

erace()	//mF
{
	PowerOn_5V();
	#CE = LOW;
	D.dir = 0;
	#OE = LOW;
	while( A < MEM_SIZE ) {
		if( D != 0xff ) {
			Message( "e͏Ă܂" );
			goto	erace_ng;
		}
		Inc( A );
	}
	Message( "eĂ܂" );
erace_ng:
	PowerOff();
}

main()
{
	Status = 0;
	write();		// 
	if( Status == 0 ) {
		verify();	// xt@C
	}
}

write()
{
	PowerOn_6V();
	Flg = 0;
	while( 1 ) {
		Len = BUFF_SIZE;
		if( DataReq( Flg, AH, AL, Buff, Len ) != 0 ) {
			Message( "݃f[^MɎs܂" );
			Status = 1;
			goto	write_end;
		}
		Flg = 1;		/* pf[^ɐݒ肵Ă */
		if( Len == 0 ) {
			break;		/* I */
		}
		A = AL;
		Clear( AD );
		do {
			Retry = 0;
			while( Retry < 25 ) {
				D = Buff[AD];
				if( D == 0xff ) {
					goto	write_skip;
				}
				#CE = LOW;
				Wait( 1, BASE_MS );
				#CE = HIGH;
				D.dir = 0;
				#OE = LOW;
				Data = D;
				#OE = HIGH;
				D.dir = 0xff;
				Retry = Retry +1;
				if( Data == Buff[AD] ) {
					goto	write_good;
				}
			}
			Message( "݂Ɏs܂" );
			Status = 1;
			goto	write_end;
write_good:
			Retry = Retry * 3;
			#CE = LOW;
			Wait( Retry, BASE_MS );
			#CE = HIGH;
write_skip:
			Inc( A );
			Inc( AD );
		} while( AD != Len );
	}
	// ݂I܂
	Message( "݂I܂" );
write_end:
	PowerOff();
}

verify()	// xt@C
{
	PowerOn_5V();
	#CE = LOW;
	D.dir = 0;
	#OE = LOW;
	Flg = 0;
	while( 1 ) {
		Len = BUFF_SIZE;
		if( DataReq( Flg, AH, AL, Buff, Len ) != 0 ) {
			Message( "xt@Cf[^MɎs܂" );
			goto	verify_end;
		}
		Flg = 1;		/* pf[^ɐݒ肵Ă */
		if( Len == 0 ) {
			break;		/* I */
		}
		A = AL;
		Clear( AD );
		do {
			if( D != Buff[AD] ) {
				Message( "xt@CɎs܂" );
				StartMsg();	// ̊Jn
				Data = A>>8;
				SendHex(Data);
				Data = A&256;
				SendHex(Data);
				SendMsg("(HEX)  ROM:");
				SendHex(D);
				SendMsg("  RAM:");
				Data = Buff[AD];
				SendHex(Data);
				EndMsg();	// ̏I
				goto	verify_end;
			}
			Inc( A );
			Inc( AD );
		} while( AD != Len );
	}
	Message( "xt@CI܂" );
verify_end:
	PowerOff();
}

read()	// ǂݏo
{
	PowerOn_5V();
	#CE = LOW;
	D.dir = 0;
	#OE = LOW;
	StartDump( 0, 0, MEM_SIZE );	// _vf[^
	while( A < MEM_SIZE ) {
		DataDump( D );
		Inc( A );
	}
	EndDump();
	Message( "ǂݏoI܂" );
	PowerOff();
}
